'''
Created on 2011-01-20

@author: Chris
'''

import pygame
import sys, os

#this module contains all of the methods needed to load 
#images, sounds, etc. into the game.

#loads a sprite sheet and slices it into sections of width w
#this code was taken from tutorial at 
#http://shinylittlething.com/2009/07/21/pygame-and-animated-sprites/
def load_sliced_sprites(w, h, filename):
    '''
    Specs :
        Master can be any height.
        Sprites frames width must be the same width
        Master width must be len(frames)*frame.width
    Assuming you ressources directory is named "ressources"
    '''
    images = []
    master_image = pygame.image.load(os.path.join('data', filename)).convert_alpha()
 
    master_width, master_height = master_image.get_size()
    for i in xrange(int(master_width/w)):
        images.append(master_image.subsurface((i*w,0,w,h)))
    return images



#this code was taken from tutorial at 
#http://www.pygame.org/docs/tut/chimp/ChimpLineByLine.html
def load_sound(name):
    class NoneSound:
        def play(self): pass
    if not pygame.mixer:
        return NoneSound()
    fullname = os.path.join('data', name)
    try:
        sound = pygame.mixer.Sound(fullname)
    except pygame.error, message:
        print 'Cannot load sound:', name
        raise SystemExit, message
    return sound

