'''
Created on 2011-02-01

@author: Chris
'''

import pygame
import random


class Object(pygame.sprite.Sprite):
    """ a generic object in the game level """
    def __init__(self, initial_position, sprite_image):
        pygame.sprite.Sprite.__init__(self) #call Sprite intializer
        
        self.image = sprite_image
        self.dummy_vbl = 0
        
        # Make our top-left corner the passed-in location.
        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        
    
    
    
    def update(self):
        pass
    
    
    
    
    
    
class CasinoGame(pygame.sprite.Sprite):
    """ a slotmachine object in the game level """
    def __init__(self, initial_position, sprite_image,win_percent):
        pygame.sprite.Sprite.__init__(self) #call Sprite intializer
        
        self.CHEAT_DISPLACEMENT = 0.03
        self.MAX_CHEAT_PERCENTAGE = 0.65
        self.MIN_CHEAT_PERCENTAGE = 0.25
        
        self.image = sprite_image
        self.cheat_percentage = 0.25
        self.WIN_PERCENTAGE = win_percent
        self.PAYBACK_MULTIPLIER = 2
        
        # Make our top-left corner the passed-in location.
        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        
    def get_cheat_increase_string(self):
        """ returns an int """
        return str(int(self.cheat_percentage*100))
    
    def bet(self,bet_amount,cheat=False):
        """calculates payout based on a $50 bet"""
        """returns and int"""
        #random.random() generates a float between (0.0,1.0)
        random_num = random.random()
        win_percentage = self.WIN_PERCENTAGE
        if cheat:
            win_percentage += self.cheat_percentage
            
        if random_num <= win_percentage:
            #player wins
            
            if cheat:
                #cheat percentage increases
                self.cheat_percentage += self.CHEAT_DISPLACEMENT
                if self.cheat_percentage > self.MAX_CHEAT_PERCENTAGE:
                    self.cheat_percentage = self.MAX_CHEAT_PERCENTAGE
            
            return self.PAYBACK_MULTIPLIER*bet_amount
            
        else:
            #player loses
            if cheat:
                #cheat percentage decreases
                self.cheat_percentage -= self.CHEAT_DISPLACEMENT
                if self.cheat_percentage < self.MIN_CHEAT_PERCENTAGE:
                    self.cheat_percentage = self.MIN_CHEAT_PERCENTAGE
            return -bet_amount
    
    
    def update(self):
        pass